.\"   $NetBSD: fdc.4,v 1.12 2003/06/27 18:28:32 wiz Exp $
.\"
.\" Copyright (c) 1996, 1997 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by John Kohl.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd November 28, 1996
.Dt FDC 4 i386
.Os
.Sh NAME
.Nm fdc
.Nd NEC 765 floppy disk controller driver
.Sh SYNOPSIS
.Cd "fdc0 at isa? port 0x3f0 irq 6 drq 2"
.Cd "fdc* at acpi?"
.Cd "fdc* at pnpbios? index ?"
.Cd "fd*  at fdc? drive ?"
.Sh DESCRIPTION
The
.Nm
driver provides support for the NEC 765 floppy disk controller and
floppy disk drives, commonly found on IBM-PC compatible systems.
.Pp
The driver supports the following floppy diskette formats by using
particular partitions:
.Bl -tag -width xxxx -offset indent -compact
.It 1.44MB 3.5-inch (b)
.It "1.2MB " 5.25-inch (c)
.It "360KB " 5.25-inch (1.2MB drive) (d)
.It "360KB " 5.25-inch (IBM-PC drive) (e)
.It "720KB " 3.5-inch (f)
.It "720KB " 5.25-inch (g)
.It "360KB " 3.5-inch (h)
.El
Partition
.Ar a
selects the default format for the attached floppy drive, as determined
by the BIOS configuration for the diskette drive.
.Sh FORMATTING
The driver supports floppy disk formatting using the interfaces in
.Aq Pa sys/fdio.h :
.Bl -tag -width FDIOCFORMAT_TRACK -compact
.It Dv FDIOCGETFORMAT Fa struct fdformat_parms
Fetch current formatting parameters.  This gets the default parameters
for the open device if no parameters have been set during the session.
.It Dv FDIOCSETFORMAT Fa struct fdformat_parms
Set formatting parameters.
The driver saves this state and it persists while the device is open.
.It Dv FDIOCFORMAT_TRACK Fa struct fdformat_cmd
Format a track on the medium.
If this call returns
.Er EINVAL ,
the track formatting parameters were out of range for the medium.
If it returns
.Er EIO ,
there was a medium error while formatting the track.
.It Dv FDIOCSETOPTS Fa int
Set driver options which persist until the device is closed.  The
options should be the logical OR of the desired values below:
.Bl -tag -width FDOPT_NORETRY -compact
.It Dv FDOPT_NORETRY
Do not retry operations on failure
.It Dv FDOPT_SILENT
Do not print error messages to the console
.El
.It Dv FDIOCGETOPTS Fa int
Fetch drive options.
.El
.Pp
A typical use of the formatting facilities would be to open the device,
call
.Dv FDIOCGETFORMAT
to fetch the current format parameters, perhaps
change a parameter or two, display the formatting details to the user,
and then call
.Dv FDIOCSETFORMAT
followed by a series of calls to
.Dv FDIOCFORMAT_TRACK .
.Sh SEE ALSO
.Xr fdformat 1 ,
.Xr acpi 4 ,
.Xr isa 4 ,
.Xr pnpbios 4
.Sh HISTORY
The
.Nm
formatting support appeared in
.Nx 1.3 .
